
// day 1_04: pct based animation with powf multiple
// zach lieberman - thesystemis.com / zlieb@parsons.edu
// ----------------------------------------------------
// animation based on a pct (number from 0-1) to move from point A to point B
// using this formula : pos.x = (1-pct) * pointA.x + (pct) * pointB.x;
// - same as previous code, but now we are shaping the pct (as it goes from 0-1)
// to either start fast and slow down or start slow and speed up
// - now, lets make a bunch so we can compare...


rectangle myRectangles[];
int nRectangles;
float pct;

//-------------------------------------------------------------------
void setup(){
  size(400,200);
  
  nRectangles = 10;
  myRectangles = new rectangle[nRectangles];
  for (int i = 0; i < nRectangles; i++){
    myRectangles[i] = new rectangle();
    myRectangles[i].pta.set(0,i*20);
    myRectangles[i].ptb.set(300,i*20);
    myRectangles[i].pctShaper = (i+1)*0.2;
  }
 
  pct = 0;
}

//-------------------------------------------------------------------
void draw(){
  
  background(245,17,230);
  
  // move via pct, and increase pct:
  for (int i = 0; i < nRectangles; i++){
    myRectangles[i].moveToPct(pct);
  }
  pct = pct + 0.005;
  if (pct > 1) pct = 0;
  
  // then draw:
  for (int i = 0; i < nRectangles; i++){
    myRectangles[i].draw();
  }
  
  
}

