

//-------------------------------------------------------------------
class xenoRectangle {
  
  Vec2D pos;
  float speed;
  float angle;
  Vec2D prevPos;
  
  //--------------------------
  // contructor:
  xenoRectangle(){
    pos = new Vec2D(50,60);
    prevPos = new Vec2D(0,0);
    speed = 0.02;
  }
  
  //--------------------------
  void catchPoint(float x, float y){
      
      // there are two ways to write this:
      // (a) using pcts (imagine mixing a glass of orange juice and a glass of water)   
      pos.x = (1-speed)*pos.x + (speed)*x;
      pos.y = (1-speed)*pos.y + (speed)*y;
      // (b) using the remaining distance:
      //pos.x = pos.x + (speed)*(x - pos.x);
      //pos.y = pos.y + (speed)*(y - pos.y);
      
      // this is the difference between the previous frame and the current
      float dx = pos.x - prevPos.x;
      float dy = pos.y - prevPos.y;
      angle = atan2(dy, dx);
      
      // take a snapshot:
      prevPos.set(pos.x, pos.y);
  }
  
  //--------------------------
  void draw(){ 
    rectMode(CENTER); 
    noStroke();
    fill(198,246,55); 
    pushMatrix();
    translate(pos.x, pos.y);
    rotate(angle);
    rect(0,0, 20,20);
    popMatrix();
  } 
  
}

