
// day_2_03: particle mutiple
// zach lieberman - thesystemis.com / zlieb@parsons.edu
// ----------------------------------------------------
// now we have a particle that has a position, velocity and force...
// we add to force to velocity, velocity to position every frame. 
// we reset the forces every frame, and sum up all the forces that are acting on the particle
//
// now, let's make a bunch and use the mouse to allocation them.
// we will have a variable that follows the mouse, and a prev variable too
// so we know velocity



ArrayList myParticles;
Vec2D mousePos;
Vec2D mousePosPrev;

//-------------------------------------------------------------------
void setup(){
  size(400,200);
  myParticles = new ArrayList();
  mousePos = new Vec2D(0,0);
  mousePosPrev = new Vec2D(0,0);
  
}

//-------------------------------------------------------------------
void draw(){
  
  background(245,17,230);
  
  for (int i = 0; i < myParticles.size(); i++){
    particle p = (particle) myParticles.get(i);
    p.resetForce();
    p.addDampingForce();
    p.update();
  }
  
  noFill();
  stroke(255);
  beginShape();
  for (int i = 0; i < myParticles.size(); i++){
    particle p = (particle) myParticles.get(i);
    vertex(p.pos.x, p.pos.y);
  }
  endShape();
   
}

void mouseDragged(){
  mousePos.x = 0.9*mousePos.x + 0.1*mouseX;   // we will SMOOTH out mouse position;
  mousePos.y = 0.9*mousePos.y + 0.1*mouseY;
  
  float velx = mousePos.x - mousePosPrev.x;
  float vely = mousePos.y - mousePosPrev.y;
  
  if (myParticles.size() > 50) myParticles.remove(0);
  particle myParticle = new particle();
  myParticle.setInitialCondition(mouseX, mouseY, velx, vely);
  myParticles.add(myParticle);
  
  mousePosPrev.x = mousePos.x;
  mousePosPrev.y = mousePos.y;
}

void mousePressed(){
  
  mousePos.x = mouseX;
  mousePos.y = mouseY;
  mousePosPrev.x = mousePos.x;
  mousePosPrev.y = mousePos.y;
}
