// day_2_05: particle vector fields
// zach lieberman - thesystemis.com / zlieb@parsons.edu
// ----------------------------------------------------
// now, we put the particles on top of an image, where every pixel is a vec2d
// this gives them some force in different directions...


particle myParticles[];
vectorField VF;

//-------------------------------------------------------------------
void setup(){
  size(400,200);
  myParticles = new particle[100];
  for (int i = 0; i < 100; i++){
    myParticles[i] = new particle();
    myParticles[i].setInitialCondition(random(0,width), random(0,height), 0.0,0.0);
  }
  VF = new vectorField();
  VF.addToFieldAnInwardCircleShape(0.5,0.5,10,1);
}

//-------------------------------------------------------------------
void draw(){
  
  background(245,17,230);
  
  VF.fadeField(0.97);
  
  for (int i = 0; i <100; i++){
    myParticles[i].resetForce();
    
    float normalizedx =  myParticles[i].pos.x / width;
    float normalizedy =  myParticles[i].pos.y / height;
    Vec2D forceFromVf = new Vec2D(0,0);
    VF.getVelFromPos(normalizedx, normalizedy, forceFromVf);
    myParticles[i].addForce(forceFromVf.x, forceFromVf.y);
    myParticles[i].addDampingForce();
    myParticles[i].update();
  }
  
  VF.draw(width,height);
  
  for (int i = 0; i <100; i++){
    myParticles[i].draw();
  }
}


void mouseDragged(){
 VF.addToFieldAnInwardCircleShape(mouseX/(float)width,mouseY/(float)height,10,1); 
}

